Gecode::FlatZinc::IntBoolVarBranch Class Reference

Which integer or Boolean variable to select for branching. More...

`#include <branch.hh>`

## Public Types

enum | Select { SEL_AFC_MAX , SEL_ACTION_MAX , SEL_CHB_MAX , SEL_AFC_SIZE_MAX , SEL_ACTION_SIZE_MAX , SEL_CHB_SIZE_MAX }
| Which variable selection. More...
Public Types inherited from Gecode::VarBranch< IntVar >
typedef BranchTraits< IntVar >::Merit | MeritFunction
| Corresponding merit function.

## Public Member Functions

| IntBoolVarBranch (Select s, double d)
| Initialize with selection strategy s and decay factor d.
| IntBoolVarBranch (Select s, IntAFC i, BoolAFC b)
| Initialize with selection strategy s and AFC i and b.
| IntBoolVarBranch (Select s, IntAction i, BoolAction b)
| Initialize with selection strategy s and action i and b.
| IntBoolVarBranch (Select s, IntCHB i, BoolCHB b)
| Initialize with selection strategy s and CHB i and b.
Select | select (void) const
| Return selection strategy.
IntAFC | intafc (void) const
| Return integer AFC.
BoolAFC | boolafc (void) const
| Return Boolean AFC.
IntAction | intaction (void) const
| Return integer action.
BoolAction | boolaction (void) const
| Return Boolean action.
IntCHB | intchb (void) const
| Return integer CHB.
BoolCHB | boolchb (void) const
| Return Boolean AFC.
void | expand (Home home, const IntVarArgs &x, const BoolVarArgs &y)
| Expand AFC, action, and CHB.
Public Member Functions inherited from Gecode::VarBranch< IntVar >
| VarBranch (void)
| Initialize.
BranchTbl | tbl (void) const
| Return tie-break limit function.
Rnd | rnd (void) const
| Return random number generator.
double | decay (void) const
| Return decay factor.
AFC | afc (void) const
| Return AFC.
Action | action (void) const
| Return action.
CHB | chb (void) const
| Return CHB.
MeritFunction | merit (void) const
| Return merit function.

## Protected Attributes

Select | s
| Which variable to select.
IntAFC | iafc
| Integer AFC.
BoolAFC | bafc
| Boolean AFC.
IntAction | iaction
| Integer action.
BoolAction | baction
| Boolean action.
IntCHB | ichb
| Integer CHB.
BoolCHB | bchb
| Boolean CHB.
Protected Attributes inherited from Gecode::VarBranch< IntVar >
BranchTbl | _tbl
| Tie-breaking limit function.
Rnd | _rnd
| Random number generator.
double | _decay
| Decay information for AFC and action.
AFC | _afc
| AFC information.
Action | _act
| Action information.
CHB | _chb
| CHB information.
MeritFunction | _mf
| Merit function.

## Detailed Description

Which integer or Boolean variable to select for branching.

Definition at line 44 of file branch.hh.

## Member Enumeration Documentation

## Select

enum Gecode::FlatZinc::IntBoolVarBranch::Select

Which variable selection.

Enumerator
SEL_AFC_MAX | With largest accumulated failure count.
SEL_ACTION_MAX | With highest action.
SEL_CHB_MAX | With highest CHB Q-score.
SEL_AFC_SIZE_MAX | With largest accumulated failure count divided by domain size.
SEL_ACTION_SIZE_MAX | With largest action divided by domain size.
SEL_CHB_SIZE_MAX | With largest CHB Q-score divided by domain size.

Definition at line 47 of file branch.hh.

## Constructor & Destructor Documentation

## IntBoolVarBranch() [1/4]

Gecode::FlatZinc::IntBoolVarBranch::IntBoolVarBranch | ( | Select | s,
|  | double | d )

inline

Initialize with selection strategy s and decay factor d.

Definition at line 37 of file branch.hpp.

## IntBoolVarBranch() [2/4]

Gecode::FlatZinc::IntBoolVarBranch::IntBoolVarBranch | ( | Select | s,
|  | IntAFC | i,
|  | BoolAFC | b )

inline

Initialize with selection strategy s and AFC i and b.

Definition at line 41 of file branch.hpp.

## IntBoolVarBranch() [3/4]

Gecode::FlatZinc::IntBoolVarBranch::IntBoolVarBranch | ( | Select | s,
|  | IntAction | i,
|  | BoolAction | b )

inline

Initialize with selection strategy s and action i and b.

Definition at line 45 of file branch.hpp.

## IntBoolVarBranch() [4/4]

Gecode::FlatZinc::IntBoolVarBranch::IntBoolVarBranch | ( | Select | s,
|  | IntCHB | i,
|  | BoolCHB | b )

inline

Initialize with selection strategy s and CHB i and b.

Definition at line 49 of file branch.hpp.

## Member Function Documentation

## select()

IntBoolVarBranch::Select Gecode::FlatZinc::IntBoolVarBranch::select | ( | void |  | ) | const

inline

Return selection strategy.

Definition at line 53 of file branch.hpp.

## intafc()

IntAFC Gecode::FlatZinc::IntBoolVarBranch::intafc | ( | void |  | ) | const

inline

Return integer AFC.

Definition at line 58 of file branch.hpp.

## boolafc()

BoolAFC Gecode::FlatZinc::IntBoolVarBranch::boolafc | ( | void |  | ) | const

inline

Return Boolean AFC.

Definition at line 62 of file branch.hpp.

## intaction()

IntAction Gecode::FlatZinc::IntBoolVarBranch::intaction | ( | void |  | ) | const

inline

Return integer action.

Definition at line 67 of file branch.hpp.

## boolaction()

BoolAction Gecode::FlatZinc::IntBoolVarBranch::boolaction | ( | void |  | ) | const

inline

Return Boolean action.

Definition at line 71 of file branch.hpp.

## intchb()

IntCHB Gecode::FlatZinc::IntBoolVarBranch::intchb | ( | void |  | ) | const

inline

Return integer CHB.

Definition at line 76 of file branch.hpp.

## boolchb()

BoolCHB Gecode::FlatZinc::IntBoolVarBranch::boolchb | ( | void |  | ) | const

inline

Return Boolean AFC.

Definition at line 80 of file branch.hpp.

## expand()

void Gecode::FlatZinc::IntBoolVarBranch::expand | ( | Home | home,
|  | const IntVarArgs & | x,
|  | const BoolVarArgs & | y )

inline

Expand AFC, action, and CHB.

Definition at line 84 of file branch.hpp.

## Member Data Documentation

## s

Select Gecode::FlatZinc::IntBoolVarBranch::s

protected

Which variable to select.

Definition at line 57 of file branch.hh.

## iafc

IntAFC Gecode::FlatZinc::IntBoolVarBranch::iafc

protected

Integer AFC.

Definition at line 59 of file branch.hh.

## bafc

BoolAFC Gecode::FlatZinc::IntBoolVarBranch::bafc

protected

Boolean AFC.

Definition at line 61 of file branch.hh.

## iaction

IntAction Gecode::FlatZinc::IntBoolVarBranch::iaction

protected

Integer action.

Definition at line 63 of file branch.hh.

## baction

BoolAction Gecode::FlatZinc::IntBoolVarBranch::baction

protected

Boolean action.

Definition at line 65 of file branch.hh.

## ichb

IntCHB Gecode::FlatZinc::IntBoolVarBranch::ichb

protected

Integer CHB.

Definition at line 67 of file branch.hh.

## bchb

BoolCHB Gecode::FlatZinc::IntBoolVarBranch::bchb

protected

Boolean CHB.

Definition at line 69 of file branch.hh.

The documentation for this class was generated from the following files:

- gecode/flatzinc/branch.hh
- gecode/flatzinc/branch.hpp